/[gentoo-x86]/eclass/depend.apache.eclass
Gentoo

Diff of /eclass/depend.apache.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.23 Revision 1.34
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2007 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/depend.apache.eclass,v 1.23 2005/09/19 00:03:55 vericgar Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/depend.apache.eclass,v 1.34 2007/09/08 14:06:12 hollow Exp $
4 4
5inherit multilib 5inherit multilib
6
7# This eclass handles depending on apache in a sane way and providing
8# information about where certain interfaces are located.
9
10# NOTE: If you use this, be sure you use the need_* call after you have
11# defined DEPEND and RDEPEND. Also note that you can not rely on the
12# automatic RDEPEND=DEPEND that portage does if you use this eclass.
13# See bug 107127 for more information.
6 14
7###### 15######
8## Apache Common Variables 16## Apache Common Variables
9## 17##
10## These are internal variables used by this, and other apache-related eclasses, 18## These are internal variables used by this, and other apache-related eclasses,
13###### 21######
14 22
15#### 23####
16## APACHE_VERSION 24## APACHE_VERSION
17## 25##
18## Stores the version of apache we are going to be ebuilding. This variable is 26## Stores the version of apache we are going to be ebuilding. This variable is
19## set by the need_apache{|1|2} functions. 27## set by the need_apache{|1|2} functions.
20## 28##
21## This needs to stay as '1' until apache2 is on by default -- although it
22## doesn't matter much as it's set by the need_apache functions.
23#### 29####
24APACHE_VERSION='1' 30#APACHE_VERSION="2"
25 31
26#### 32####
27## APXS1, APXS2 33## APXS1, APXS2
28## 34##
29## Paths to the apxs tools 35## Paths to the apxs tools
42#### 48####
43## APACHE1_BASEDIR, APACHE2_BASEDIR 49## APACHE1_BASEDIR, APACHE2_BASEDIR
44## 50##
45## Paths to the server root directories 51## Paths to the server root directories
46#### 52####
47#APACHE1_BASEDIR="/usr/$(get_libdir)/apache" 53APACHE1_BASEDIR="/usr/$(get_libdir)/apache"
48#APACHE2_BASEDIR="/usr/$(get_libdir)/apache2" 54APACHE2_BASEDIR="/usr/$(get_libdir)/apache2"
49APACHE1_BASEDIR="/usr/lib/apache"
50APACHE2_BASEDIR="/usr/lib/apache2"
51 55
52#### 56####
53## APACHE1_CONFDIR, APACHE2_CONFDIR 57## APACHE1_CONFDIR, APACHE2_CONFDIR
54## 58##
55## Paths to the configuration file directories (usually under 59## Paths to the configuration file directories
56## $APACHE?_BASEDIR/conf)
57#### 60####
58APACHE1_CONFDIR="/etc/apache" 61APACHE1_CONFDIR="/etc/apache"
59APACHE2_CONFDIR="/etc/apache2" 62APACHE2_CONFDIR="/etc/apache2"
60 63
61#### 64####
82APACHE1_MODULESDIR="${APACHE1_BASEDIR}/modules" 85APACHE1_MODULESDIR="${APACHE1_BASEDIR}/modules"
83APACHE2_MODULESDIR="${APACHE2_BASEDIR}/modules" 86APACHE2_MODULESDIR="${APACHE2_BASEDIR}/modules"
84 87
85#### 88####
86## APACHE1_DEPEND, APACHE2_DEPEND 89## APACHE1_DEPEND, APACHE2_DEPEND
90## APACHE2_0_DEPEND, APACHE2_2_DEPEND
87## 91##
88## Dependencies for apache 1.x and apache 2.x 92## Dependencies for Apache 1.x and Apache 2.x
89## - apache2 must be at least version 2.0.54-r30, this is lowest version
90## containing our new overall changes -- trapni (Jan 21 2005)
91## - apache1 must be at least version 1.3.33-r10, but how to
92## define the DEPEND here? (FIXME) -- trapni (Jan 21 2005)
93## - currently not possible - bug #4315 -- vericgar (Jan 21 2005)
94#### 93####
95APACHE1_DEPEND="=net-www/apache-1*" 94APACHE1_DEPEND="=www-servers/apache-1*"
96APACHE2_DEPEND=">=net-www/apache-2.0.54-r30" 95APACHE2_DEPEND="=www-servers/apache-2*"
96APACHE2_0_DEPEND="=www-servers/apache-2.0*"
97APACHE2_2_DEPEND="=www-servers/apache-2.2*"
97 98
98#### 99####
99## APACHE_DEPEND 100## NEED_APACHE_DEPEND
100## 101##
101## Dependency magic based on useflags to use the right DEPEND 102## Dependency magic based on useflags to use the right DEPEND
103## If you change this, please check the DEPENDS in need_apache()
102#### 104####
103 105
104NEED_APACHE_DEPEND="apache2? ( ${APACHE2_DEPEND} ) !apache2? ( ${APACHE1_DEPEND} )" 106NEED_APACHE_DEPEND="${APACHE2_DEPEND}"
105WANT_APACHE_DEPEND="apache2? ( ${APACHE2_DEPEND} ) !apache2? ( apache? ( ${APACHE1_DEPEND} ) )" 107WANT_APACHE_DEPEND="apache2? ( ${APACHE2_DEPEND} )"
106 108
107#### 109####
108# uses_apache1() 110## apr_config/apu_config
109# 111##
110# sets up all of the environment variables required by an apache1 module 112## Version magic to get the correct apr-config/apu-config
113## based on the (probably) installed version of apache.
114## This is needed to get modules to link to the same apr/apu
115## as apache (i.e. link 0.9 for 2.0, 1.x for 2.2)
116####
117apr_config() {
118 local default="${1:-1}"
119 if [[ "${USE_APACHE}" == "2" ]]; then
120 if has_version ${APACHE2_0_DEPEND}; then
121 echo apr-config
122 else
123 echo apr-1-config
124 fi
125 else
126 if [[ "${default}" == "0" ]]; then
127 echo apr-config
128 elif [[ "${default}" == "1" ]]; then
129 echo apr-1-config
130 else
131 die "Unknown version specifier: ${default}"
132 fi
133 fi
134}
135
136apu_config() {
137 local default="${1:-1}"
138 if [[ "${USE_APACHE}" == "2" ]]; then
139 if has_version ${APACHE2_0_DEPEND}; then
140 echo apu-config
141 else
142 echo apu-1-config
143 fi
144 else
145 if [[ "${default}" == "0" ]]; then
146 echo apu-config
147 elif [[ "${default}" == "1" ]]; then
148 echo apu-1-config
149 else
150 die "Unknown version specifier: ${default}"
151 fi
152 fi
153}
154
155####
156# uses_apache1() - !!! DEPRECATED !!!
111#### 157####
112 158
113uses_apache1() { 159uses_apache1() {
160 debug-print-function $FUNCNAME $*
161 # WARNING: Do not use these variables with anything that is put
162 # into the dependency cache (DEPEND/RDEPEND/etc)
114 APACHE_VERSION='1' 163 APACHE_VERSION="1"
115 APXS="$APXS1" 164 APXS="${APXS1}"
116 USE_APACHE2= 165 USE_APACHE="1"
117 APACHECTL="${APACHECTL1}" 166 APACHECTL="${APACHECTL1}"
118 APACHE_BASEDIR="${APACHE1_BASEDIR}" 167 APACHE_BASEDIR="${APACHE1_BASEDIR}"
119 APACHE_CONFDIR="${APACHE1_CONFDIR}" 168 APACHE_CONFDIR="${APACHE1_CONFDIR}"
120 APACHE_MODULES_CONFDIR="${APACHE1_MODULES_CONFDIR}" 169 APACHE_MODULES_CONFDIR="${APACHE1_MODULES_CONFDIR}"
121 APACHE_VHOSTSDIR="${APACHE1_VHOSTSDIR}" 170 APACHE_VHOSTSDIR="${APACHE1_VHOSTSDIR}"
127# 176#
128# sets up all of the environment variables required by an apache2 module 177# sets up all of the environment variables required by an apache2 module
129#### 178####
130 179
131uses_apache2() { 180uses_apache2() {
181 debug-print-function $FUNCNAME $*
182 # WARNING: Do not use these variables with anything that is put
183 # into the dependency cache (DEPEND/RDEPEND/etc)
132 APACHE_VERSION='2' 184 APACHE_VERSION="2"
133 USE_APACHE2=2 185 USE_APACHE="2"
134 APXS="$APXS2" 186 APXS="${APXS2}"
135 APACHECTL="${APACHECTL2}" 187 APACHECTL="${APACHECTL2}"
136 APACHE_BASEDIR="${APACHE2_BASEDIR}" 188 APACHE_BASEDIR="${APACHE2_BASEDIR}"
137 APACHE_CONFDIR="${APACHE2_CONFDIR}" 189 APACHE_CONFDIR="${APACHE2_CONFDIR}"
138 APACHE_MODULES_CONFDIR="${APACHE2_MODULES_CONFDIR}" 190 APACHE_MODULES_CONFDIR="${APACHE2_MODULES_CONFDIR}"
139 APACHE_VHOSTSDIR="${APACHE2_VHOSTSDIR}" 191 APACHE_VHOSTSDIR="${APACHE2_VHOSTSDIR}"
140 APACHE_MODULESDIR="${APACHE2_MODULESDIR}" 192 APACHE_MODULESDIR="${APACHE2_MODULESDIR}"
141} 193}
142 194
143doesnt_use_apache() { 195doesnt_use_apache() {
196 debug-print-function $FUNCNAME $*
144 APACHE_VERSION='0' 197 APACHE_VERSION="0"
145 USE_APACHE= 198 USE_APACHE="0"
146} 199}
147 200
148#### 201####
149## need_apache1 202## need_apache1 - !!! DEPRECATED !!!
150##
151## An ebuild calls this to get the dependency information
152## for apache-1.x. An ebuild should use this in order for
153## future changes to the build infrastructure to happen
154## seamlessly. All an ebuild needs to do is include the
155## line need_apache1 somewhere.
156#### 203####
157need_apache1() { 204need_apache1() {
158 debug-print-function need_apache1 205 debug-print-function $FUNCNAME $*
159 206
160 DEPEND="${DEPEND} ${APACHE1_DEPEND}" 207 DEPEND="${DEPEND} ${APACHE1_DEPEND}"
161 RDEPEND="${RDEPEND} ${APACHE1_DEPEND}" 208 RDEPEND="${RDEPEND} ${APACHE1_DEPEND}"
162 APACHE_VERSION='1' 209 APACHE_VERSION="1"
163} 210}
164 211
165#### 212####
166## need_apache2 213## need_apache2
167## 214##
168## An ebuild calls this to get the dependency information 215## An ebuild calls this to get the dependency information
169## for apache-2.x. An ebuild should use this in order for 216## for apache-2.x. An ebuild should use this in order for
170## future changes to the build infrastructure to happen 217## future changes to the build infrastructure to happen
171## seamlessly. All an ebuild needs to do is include the 218## seamlessly. All an ebuild needs to do is include the
172## line need_apache1 somewhere. 219## line need_apache2 somewhere.
173#### 220####
174need_apache2() { 221need_apache2() {
175 debug-print-function need_apache2 222 debug-print-function $FUNCNAME $*
176 223
177 DEPEND="${DEPEND} ${APACHE2_DEPEND}" 224 DEPEND="${DEPEND} ${APACHE2_DEPEND}"
178 RDEPEND="${RDEPEND} ${APACHE2_DEPEND}" 225 RDEPEND="${RDEPEND} ${APACHE2_DEPEND}"
179 APACHE_VERSION='2' 226 APACHE_VERSION="2"
227}
228
229####
230## need_apache2_0
231##
232## Works like need_apache2 above, but its used by modules
233## that only support apache 2.0 and do not work with
234## higher versions.
235##
236####
237need_apache2_0() {
238 debug-print-function $FUNCNAME $*
239
240 DEPEND="${DEPEND} ${APACHE2_0_DEPEND}"
241 RDEPEND="${RDEPEND} ${APACHE2_0_DEPEND}"
242 APACHE_VERSION="2"
243}
244
245####
246## need_apache2_2
247##
248## Works like need_apache2 above, but its used by modules
249## that only support apache 2.2 and do not work with
250## lower versions.
251##
252####
253need_apache2_2() {
254 debug-print-function $FUNCNAME $*
255
256 DEPEND="${DEPEND} ${APACHE2_2_DEPEND}"
257 RDEPEND="${RDEPEND} ${APACHE2_2_DEPEND}"
258 APACHE_VERSION="2"
180} 259}
181 260
182#### 261####
183## DO NOT CHANGE THIS FUNCTION UNLESS YOU UNDERSTAND THE CONSEQUENCES IT 262## DO NOT CHANGE THIS FUNCTION UNLESS YOU UNDERSTAND THE CONSEQUENCES IT
184## WILL HAVE ON THE CACHE! There MUST be a apache2? () block in DEPEND for 263## WILL HAVE ON THE CACHE!
185## things to work correct in the dependency calculation stage. 264##
265## This function can take a variable amount of arguments specifying the
266## versions of apache the ebuild supports
267##
268## If no arguments are specified, then all versions are assumed to be supported
269##
270## Currently supported versions: 2.0 2.2 2.x
186#### 271####
187need_apache() { 272need_apache() {
188 debug-print-function need_apache 273 debug-print-function $FUNCNAME $*
274
275 local supports2x supports20 supports22
276
277 if [[ $# -eq 0 ]] ; then
278 supports2x="yes"
279 else
280 while [[ $# -gt 0 ]] ; do
281 case "$1" in
282 2.0) supports20="yes"; shift;;
283 2.2) supports22="yes"; shift;;
284 2.x) supports2x="yes"; shift;;
285 *) die "Unknown version specifier: $1";;
286 esac
287 done
288 fi
289
290 if [[ "${supports20}" == "yes" ]] && [[ "${supports22}" == "yes" ]] ; then
291 supports2x="yes"
292 fi
293
294 debug-print "supports20: ${supports20}"
295 debug-print "supports22: ${supports22}"
296 debug-print "supports2x: ${supports2x}"
297
298 if [[ "${supports2x}" == "yes" ]] ; then
299 need_apache2
300 elif [[ "${supports20}" == "yes" ]] ; then
301 need_apache2_0
302 elif [[ "${supports22}" == "yes" ]] ; then
303 need_apache2_2
304 fi
305
306 uses_apache2
307}
308
309want_apache() {
310 debug-print-function $FUNCNAME $*
189 311
190 IUSE="${IUSE} apache2" 312 IUSE="${IUSE} apache2"
191 DEPEND="${DEPEND} ${NEED_APACHE_DEPEND}" 313 DEPEND="${DEPEND} ${WANT_APACHE_DEPEND}"
192 RDEPEND="${RDEPEND} ${NEED_APACHE_DEPEND}" 314 RDEPEND="${RDEPEND} ${WANT_APACHE_DEPEND}"
193 if useq apache2; then 315 if use apache2 ; then
194 uses_apache2 316 uses_apache2
195 else 317 else
196 uses_apache1
197 fi
198}
199
200want_apache() {
201 debug-print-function want_apache
202
203 IUSE="${IUSE} apache apache2"
204 DEPEND="${DEPEND} ${WANT_APACHE_DEPEND}"
205 RDEPEND="${DEPEND} ${WANT_APACHE_DEPEND}"
206 if useq apache2 ; then
207 uses_apache2
208 elif useq apache ; then
209 uses_apache1
210 else
211 doesnt_use_apache 318 doesnt_use_apache
212 fi 319 fi
213} 320}

Legend:
Removed from v.1.23  
changed lines
  Added in v.1.34

  ViewVC Help
Powered by ViewVC 1.1.20